#!/bin/bash

. /serwer/serwer.conf

# czyszczenie kolejek
$TC qdisc del root dev imq1 2> /dev/null > /dev/null
$TC qdisc del root dev imq2 2> /dev/null > /dev/null

# kolejki glowne na interfejsach klienckich
LICZNIK=2
QUANTUM=$((50000*1024/8/1600))
$TC qdisc add dev imq1 root handle 1:0 htb
$TC class add dev imq1 parent 1:0 classid 1:1 htb rate 100000kbit quantum $QUANTUM
$TC qdisc add dev imq2 root handle 1:0 htb
$TC class add dev imq2 parent 1:0 classid 1:1 htb rate 100000kbit quantum $QUANTUM

# panel - internet, predkosci
grep "^[^#]" ${PANEL} | while read IP DOWN UP NDOWN NUP BLOK AUTHMAC; do

    # predkosci - download
    if [ ${DOWN} != 0 ]; then
    	$TC class add dev imq2 parent 1:1 classid 1:${LICZNIK} htb rate 32kbit ceil ${DOWN}kbit quantum ${QUANTUM}
        $TC filter add dev imq2 protocol ip parent 1:0 u32 match ip dst $IP flowid 1:${LICZNIK}
        $TC qdisc add dev imq2 parent 1:${LICZNIK} handle ${LICZNIK}: sfq perturb 10
    fi

    # predkosci - upload
    if [ ${UP} != 0 ]; then
	$TC class add dev imq1 parent 1:1 classid 1:${LICZNIK} htb rate 32kbit ceil ${UP}kbit quantum $QUANTUM
	$TC filter add dev imq1 protocol ip parent 1:0 u32 match ip src $IP flowid 1:${LICZNIK}
	$TC qdisc add dev imq1 parent 1:${LICZNIK} handle ${LICZNIK}: sfq perturb 10
    fi
    LICZNIK=$((${LICZNIK}+1))
    
done
