#!/bin/bash

. /serwer/serwer.conf

htbwan(){

# procentowy podzial uslug
sygnalizacja=15
interaktywne=30
standardowe=30
lowprio=10
inne=10
p2p=5

QUANTUM=$((${4}*1024/8/1600))

# kolejka glowna
$TC qdisc add dev ${1} root handle 1:0 htb default 6
$TC class add dev ${1} parent 1:0 classid 1:1 htb rate ${4}kbit quantum $QUANTUM

# klasy uslug
$TC class add dev ${1} parent 1:1 classid 1:2 htb rate $((${4}*${sygnalizacja}/100))kbit ceil ${4}kbit prio 1 quantum $QUANTUM
$TC class add dev ${1} parent 1:1 classid 1:3 htb rate $((${4}*${interaktywne}/100))kbit ceil ${4}kbit prio 2 quantum $QUANTUM
$TC class add dev ${1} parent 1:1 classid 1:4 htb rate $((${4}*${standardowe}/100))kbit ceil ${4}kbit prio 3 quantum $QUANTUM
$TC class add dev ${1} parent 1:1 classid 1:5 htb rate $((${4}*${lowprio}/100))kbit ceil ${4}kbit prio 4 quantum $QUANTUM
$TC class add dev ${1} parent 1:1 classid 1:6 htb rate $((${4}*${inne}/100))kbit ceil $((${4}*90/100))kbit prio 5 quantum $QUANTUM
$TC class add dev ${1} parent 1:1 classid 1:7 htb rate $((${4}*${p2p}/100))kbit ceil $((${4}*80/100))kbit prio 6 quantum $QUANTUM

# filtry - sygnalizacja - ack, icmp, dns, sip
$TC filter add dev ${1} protocol ip parent 1:0 prio 1 u32 match ip protocol 6 0xff match u8 0x05 0x0f at 0 match u16 0x0000 0xffc0 at 2 match u8 0x10 0xff at 33 flowid 1:2
$TC filter add dev ${1} protocol ip parent 1:0 u32 match ip protocol 1 0xff flowid 1:2
$TC filter add dev ${1} protocol ip parent 1:0 u32 match ip ${2} 53 0xffff flowid 1:2
$TC filter add dev ${1} protocol ip parent 1:0 u32 match ip ${2} 21 0xffff flowid 1:2
$TC filter add dev ${1} protocol ip parent 1:0 handle 2 fw flowid 1:2
$TC filter add dev ${1} protocol ip parent 1:0 handle 22 fw flowid 1:2

# filtry - uslugi interaktywne - ssh, gg, vnc, vpn, https
$TC filter add dev ${1} protocol ip parent 1:0 u32 match ip ${2} 22 0xffff flowid 1:3
$TC filter add dev ${1} protocol ip parent 1:0 u32 match ip ${2} 8074 0xffff flowid 1:3
$TC filter add dev ${1} protocol ip parent 1:0 u32 match ip ${2} 443 0xffff flowid 1:3
$TC filter add dev ${1} protocol ip parent 1:0 u32 match ip ${2} 1723 0xffff flowid 1:3
$TC filter add dev ${1} protocol ip parent 1:0 u32 match ip protocol 47 0xff flowid 1:3
$TC filter add dev ${1} protocol ip parent 1:0 u32 match ip protocol 50 0xff flowid 1:3
$TC filter add dev ${1} protocol ip parent 1:0 u32 match ip protocol 51 0xff flowid 1:3
$TC filter add dev ${1} protocol ip parent 1:0 handle 3 fw flowid 1:3

# filtry - uslugi standardowe - smtp, smtps, http, pop3, pop3s, imap, shoutcast
$TC filter add dev ${1} protocol ip parent 1:0 u32 match ip ${2} 25 0xffff flowid 1:4
$TC filter add dev ${1} protocol ip parent 1:0 u32 match ip ${2} 80 0xffff flowid 1:4
$TC filter add dev ${1} protocol ip parent 1:0 u32 match ip ${2} 110 0xffff flowid 1:4
$TC filter add dev ${1} protocol ip parent 1:0 u32 match ip ${2} 465 0xffff flowid 1:4
$TC filter add dev ${1} protocol ip parent 1:0 u32 match ip ${2} 995 0xffff flowid 1:4
$TC filter add dev ${1} protocol ip parent 1:0 u32 match ip ${2} 143 0xffff flowid 1:4
$TC filter add dev ${1} protocol ip parent 1:0 handle 4 fw flowid 1:4

# filtry - uslugi lowprio - http-video, ftp
$TC filter add dev ${1} protocol ip parent 1:0 handle 5 fw flowid 1:5

# filtry - uslugi p2p
$TC filter add dev ${1} protocol ip parent 1:0 handle 7 fw flowid 1:7

# mechanizm ESFQ
$TC qdisc add dev ${1} parent 1:2 handle 2: esfq perturb 10 hash ${3}
$TC qdisc add dev ${1} parent 1:3 handle 3: esfq perturb 10 hash ${3}
$TC qdisc add dev ${1} parent 1:4 handle 4: esfq perturb 10 hash ${3}
$TC qdisc add dev ${1} parent 1:5 handle 5: esfq perturb 10 hash ${3}
$TC qdisc add dev ${1} parent 1:6 handle 6: esfq perturb 10 hash ${3}
$TC qdisc add dev ${1} parent 1:7 handle 7: esfq perturb 10 hash ${3}

}

# czyszczenie kolejek
$TC qdisc del root dev imq0 2> /dev/null > /dev/null
$TC qdisc del root dev eth0 2> /dev/null > /dev/null

# ograniczenia WAN
htbwan imq0 sport ctnatchg $DOWNLOAD
htbwan $EXTDEV dport ctnatchg $UPLOAD