#!/bin/bash

. /serwer/serwer.conf

# czyszczenie tabeli nat
$IPTABLES -F -t nat

# PRZEKIEROWANIA publicznych IP do LAN
grep "^[^#]" ${PUB} | while read PUBIP IP; do
    $IPTABLES -t nat -A PREROUTING -d ${PUBIP} -j DNAT --to-destination ${IP}
    $IPTABLES -t nat -A POSTROUTING -s ${IP} -j SNAT --to-source ${PUBIP}
done

# MASKARADA dla wszystkiego
$IPTABLES -t nat -A POSTROUTING -s $INTNET1 -o $EXTDEV -j MASQUERADE
$IPTABLES -t nat -A POSTROUTING -s $VPNNET1 -o $EXTDEV -j MASQUERADE
$IPTABLES -t nat -A POSTROUTING -s $NOAUTH -o $EXTDEV -j MASQUERADE

# PRZEKIEROWANIE nowych
$IPTABLES -A PREROUTING -t nat -s $NOAUTH -p tcp --dport 80 -j DNAT --to-destination 10.0.0.254:202

# PRZEKIEROWANIA portow
grep "^[^#]" ${FORWARD} | while read WANPORT LANIP LANPORT; do
    $IPTABLES -t nat -A PREROUTING -d ${EXTIP} -p tcp --dport ${WANPORT} -j DNAT --to-destination ${LANIP}:${LANPORT}
    $IPTABLES -t nat -A PREROUTING -d ${EXTIP} -p udp --dport ${WANPORT} -j DNAT --to-destination ${LANIP}:${LANPORT}
done

# komunikaty i blokady
grep "^[^#]" ${PANEL} | while read IP DOWN UP NDOWN NUP BLOK AUTHMAC; do
    case "${BLOK}" in
        1)
            $IPTABLES -A PREROUTING -t nat -s $IP -p tcp --dport 80 -j DNAT --to-destination 192.168.100.254:200
        ;;

        2)
            $IPTABLES -A PREROUTING -t nat -s $IP -p tcp --dport 80 -j DNAT --to-destination 192.168.100.254:201
        ;;
    esac
done
